"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
var react_1 = __importDefault(require("react"));
var defaultColumnContext = {
  columns: [],
  toggles: undefined
};
var ColumnContext = react_1["default"].createContext(defaultColumnContext);
var ColumnProvider = function ColumnProvider(_ref) {
  var columns = _ref.columns,
    toggles = _ref.toggles,
    children = _ref.children;
  var toggleColumns;
  if (toggles) {
    toggleColumns = columns.filter(function (column) {
      return toggles[column.dataField];
    });
  } else {
    toggleColumns = columns.filter(function (column) {
      return !column.hidden;
    });
  }
  return react_1["default"].createElement(ColumnContext.Provider, {
    value: {
      columns: toggleColumns
    }
  }, children);
};
exports["default"] = function () {
  return {
    Provider: ColumnProvider,
    Consumer: ColumnContext.Consumer
  };
};