import React, { Component, ReactNode } from "react";
interface RowExpandProviderProps {
    children: ReactNode;
    data: any[];
    keyField: string;
    expandRow: {
        expanded?: any[];
        isClosing?: any[];
        onExpand?: (row: any, expanded: boolean, rowIndex: number, e: any) => void;
        onExpandAll?: (expandAll: boolean, expandedRows: any[], e: any) => void;
        onlyOneExpanding?: boolean;
        nonExpandable?: any[];
        renderer?: () => void;
    };
}
export interface RowExpandContextValue {
    expanded: any[];
    isClosing: any[];
    nonExpandable?: any[];
    onClosed: (closedRow: any) => void;
    isAnyExpands: boolean;
    onRowExpand: (rowKey: any, expanded: boolean, rowIndex: number, e: any) => void;
    onAllRowExpand: (e: any, expandAll: boolean) => void;
    onExpand?: (row: any, expanded: boolean, rowIndex: number, e: any) => void;
    onExpandAll?: (expandAll: boolean, expandedRows: any[], e: any) => void;
    onlyOneExpanding?: boolean;
}
declare class RowExpandProvider extends Component<RowExpandProviderProps> {
    state: {
        expanded: any[];
        isClosing: any[];
    };
    onClosed: (closedRow: any) => void;
    static getDerivedStateFromProps(nextProps: RowExpandProviderProps, prevState: {
        expanded: any[];
        isClosing: any[];
    }): {
        expanded: any[];
        isClosing: any;
    };
    handleRowExpand: (rowKey: any, isExpanded: boolean, rowIndex: number, e: any) => void;
    handleAllRowExpand: (e: any, expandAll: boolean) => void;
    render(): React.JSX.Element;
}
declare const _default: () => {
    Provider: typeof RowExpandProvider;
    Consumer: React.Consumer<RowExpandContextValue>;
};
export default _default;
