import React, { ReactNode } from "react";
import { SORT_ASC, SORT_DESC } from "../..";
type DataOperator = {
    nextOrder: (column: any, state: {
        sortOrder: string | undefined;
        sortColumn: any | undefined;
    }, defaultSortDirection: string) => string;
    sort: (data: any[], order: string | undefined, sortColumn: any | undefined) => any[];
};
type HandleSortChange = (dataField: string, sortOrder: string | undefined) => void;
interface SortContextValue {
    data: any[];
    sortOrder: string | undefined;
    onSort: (column: any) => void;
    sortField: string | null;
}
interface SortProviderProps {
    data: any[];
    columns: any[];
    children: ReactNode;
    defaultSorted?: Array<{
        dataField: string;
        order: typeof SORT_ASC | typeof SORT_DESC;
    }>;
    sort?: {
        dataField: string;
        order: typeof SORT_ASC | typeof SORT_DESC;
        sortFunc: (a: any, b: any, order: string, dataField: string) => number;
    };
    defaultSortDirection: typeof SORT_ASC | typeof SORT_DESC;
}
declare const _default: (dataOperator: DataOperator, isRemoteSort: () => boolean, handleSortChange: HandleSortChange) => {
    Provider: {
        new (props: SortProviderProps): {
            state: {
                sortOrder: string | undefined;
                sortColumn: {
                    dataField: string;
                    text: string;
                    onSort: Function;
                    sortFunc: Function;
                } | undefined;
            };
            componentDidMount(): void;
            initSort(sortField: string, sortOrder: string): any;
            handleSort: (column: {
                dataField: string;
                onSort: Function;
            }) => void;
            render(): React.JSX.Element;
            context: unknown;
            setState<K extends never>(state: {} | ((prevState: Readonly<{}>, props: Readonly<SortProviderProps>) => {} | Pick<{}, K> | null) | Pick<{}, K> | null, callback?: (() => void) | undefined): void;
            forceUpdate(callback?: (() => void) | undefined): void;
            readonly props: Readonly<SortProviderProps>;
            refs: {
                [key: string]: React.ReactInstance;
            };
            shouldComponentUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{}>, nextContext: any): boolean;
            componentWillUnmount?(): void;
            componentDidCatch?(error: Error, errorInfo: React.ErrorInfo): void;
            getSnapshotBeforeUpdate?(prevProps: Readonly<SortProviderProps>, prevState: Readonly<{}>): any;
            componentDidUpdate?(prevProps: Readonly<SortProviderProps>, prevState: Readonly<{}>, snapshot?: any): void;
            componentWillMount?(): void;
            UNSAFE_componentWillMount?(): void;
            componentWillReceiveProps?(nextProps: Readonly<SortProviderProps>, nextContext: any): void;
            UNSAFE_componentWillReceiveProps?(nextProps: Readonly<SortProviderProps>, nextContext: any): void;
            componentWillUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
            UNSAFE_componentWillUpdate?(nextProps: Readonly<SortProviderProps>, nextState: Readonly<{}>, nextContext: any): void;
        };
        getDerivedStateFromProps(nextProps: SortProviderProps, prevState: any): {
            sortOrder: "desc" | "asc";
            sortColumn: any;
        } | null;
        contextType?: React.Context<any> | undefined;
    };
    Consumer: React.Consumer<SortContextValue>;
};
export default _default;
