"use strict";

var __importDefault = void 0 && (void 0).__importDefault || function (mod) {
  return mod && mod.__esModule ? mod : {
    "default": mod
  };
};
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getExpandedRows = exports.expandableKeys = exports.isAnyExpands = void 0;
var utils_1 = __importDefault(require("../utils"));
var rows_1 = require("./rows");
var isAnyExpands = function isAnyExpands(data, keyField) {
  var expanded = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  var _loop = function _loop() {
      var rowKey = utils_1["default"].get(data[i], keyField);
      if (typeof expanded.find(function (x) {
        return x === rowKey;
      }) !== "undefined") {
        return {
          v: true
        };
      }
    },
    _ret;
  for (var i = 0; i < data.length; i += 1) {
    _ret = _loop();
    if (_ret) return _ret.v;
  }
  return false;
};
exports.isAnyExpands = isAnyExpands;
var expandableKeys = function expandableKeys(data, keyField) {
  var skips = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
  if (skips.length === 0) {
    return data.map(function (row) {
      return utils_1["default"].get(row, keyField);
    });
  }
  return data.filter(function (row) {
    return !utils_1["default"].contains(skips, utils_1["default"].get(row, keyField));
  }).map(function (row) {
    return utils_1["default"].get(row, keyField);
  });
};
exports.expandableKeys = expandableKeys;
var getExpandedRows = function getExpandedRows(data, keyField, expanded) {
  return expanded.map(function (k) {
    return (0, rows_1.getRowByRowId)(data, keyField, k);
  });
};
exports.getExpandedRows = getExpandedRows;